local VUHDO_CUSTOM_DEBUFF_LIST = { };
local VUHDO_UNIT_CUSTOM_DEBUFFS = { };
local VUHDO_LAST_UNIT_DEBUFFS = { };


local VUHDO_NEXT_SOUND_TIME = 0;

-- BURST CACHE ---------------------------------------------------

local VUHDO_CONFIG;
local VUHDO_RAID;
local VUHDO_PANEL_SETUP;

local VUHDO_isInFight;

local UnitDebuff = UnitDebuff;
local UnitBuff = UnitBuff;
local table = table;

function VUHDO_debuffsInitBurst()
	VUHDO_CONFIG = VUHDO_GLOBAL["VUHDO_CONFIG"];
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];

	VUHDO_isInFight = VUHDO_GLOBAL["VUHDO_isInFight"];
end

----------------------------------------------------


local tCnt;
local tIsRmOnly;
local tName, tIcon, tType;
local tChosen;
local tDebuff;
local tAbility;
local tDebuffType;



--
local tUnit, tInfo;
function VUHDO_updateAllCustomDebuffs(anIsEnableAnim)
	table.wipe(VUHDO_UNIT_CUSTOM_DEBUFFS);
	VUHDO_MAY_DEBUFF_ANIM = false;
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		VUHDO_removeAllDebuffIcons(tUnit);
		tInfo.debuff, tInfo.debuffName = VUHDO_determineDebuff(tUnit, tInfo.class);
	end
	VUHDO_MAY_DEBUFF_ANIM = anIsEnableAnim;
end



--
local tSourceColor;
local tDebuffSettings;
local tMiBuColor = { };
local tCustomColor = { };
function VUHDO_getDebuffColor(anInfo)
	if (anInfo.charmed) then
		return VUHDO_PANEL_SETUP["BAR_COLORS"]["CHARMED"];
	end

	tDebuffSettings = VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][anInfo.debuffName];

	if (anInfo.debuff ~= VUHDO_DEBUFF_TYPE_CUSTOM and VUHDO_PANEL_SETUP["BAR_COLORS"]["DEBUFF" .. anInfo.debuff] ~= nil) then
		return VUHDO_PANEL_SETUP["BAR_COLORS"]["DEBUFF" .. anInfo.debuff];
	elseif (tDebuffSettings and tDebuffSettings.isColor) then
		table.wipe(tCustomColor);
		
		if (VUHDO_PANEL_SETUP.BAR_COLORS.DEBUFF6.useBackground) then
			tCustomColor.R = tDebuffSettings.color.R;
			tCustomColor.G = tDebuffSettings.color.G;
			tCustomColor.B = tDebuffSettings.color.B;
			tCustomColor.O = tDebuffSettings.color.O;
			tCustomColor.useBackground = true;
		end

		if (VUHDO_PANEL_SETUP.BAR_COLORS.DEBUFF6.useText) then
			tCustomColor.TR = tDebuffSettings.color.TR;
			tCustomColor.TG = tDebuffSettings.color.TG;
			tCustomColor.TB = tDebuffSettings.color.TB;
			tCustomColor.TO = tDebuffSettings.color.TO;
			tCustomColor.useText = true;
		end
		return tCustomColor;
	end

	table.wipe(tMiBuColor);

	if (anInfo.mibucateg == nil) then
		return tMiBuColor;
	end

	tSourceColor = VUHDO_BUFF_SETTINGS[anInfo.mibucateg].missingColor;
	if (VUHDO_BUFF_SETTINGS["CONFIG"]["BAR_COLORS_TEXT"]) then
		tMiBuColor.useText = true;
		tMiBuColor.TR = tSourceColor.TR;
		tMiBuColor.TG = tSourceColor.TG;
		tMiBuColor.TB = tSourceColor.TB;
		tMiBuColor.TO = tSourceColor.TO;
	end

	if (VUHDO_BUFF_SETTINGS["CONFIG"]["BAR_COLORS_BACKGROUND"]) then
		tMiBuColor.useBackground = true;
		tMiBuColor.R = tSourceColor.R;
		tMiBuColor.G = tSourceColor.G;
		tMiBuColor.B = tSourceColor.B;
		tMiBuColor.O = tSourceColor.O;
	end

	return tMiBuColor;
end



--
function VUHDO_hasUnitInfoDebuff(anInfo)
	return anInfo.debuff ~= VUHDO_DEBUFF_TYPE_NONE or anInfo.charmed;
end



--
local function VUHDO_isDebuffRelevant(aDebuffName, aUnitClassFileName)
	if (VUHDO_IGNORE_DEBUFFS_BY_CLASS[aUnitClassFileName][aDebuffName]) then
		return false;
	end

	if (VUHDO_CONFIG["DETECT_DEBUFFS_IGNORE_NO_HARM"] and VUHDO_IGNORE_DEBUFFS_NO_HARM[aDebuffName]) then
		return false;
	end

	if (VUHDO_CONFIG["DETECT_DEBUFFS_IGNORE_MOVEMENT"] and VUHDO_IGNORE_DEBUFFS_MOVEMENT[aDebuffName]) then
		return false;
	end

	if (VUHDO_CONFIG["DETECT_DEBUFFS_IGNORE_DURATION"] and VUHDO_IGNORE_DEBUFFS_DURATION[aDebuffName]) then
		return false;
	end

	return true;
end



--
local tDebuffInfo;
local function VUHDO_isCustomDebuff(aName)
	tDebuffInfo = VUHDO_CUSTOM_DEBUFF_LIST[aName];
	if (tDebuffInfo ~= nil) then
		return tDebuffInfo[1], tDebuffInfo[2];
	else
		return false, false;
	end
end



local VUHDO_CUSTOM_BUFF_BLACKLIST = {
	[GetSpellInfo(67847)] = true -- Expose Weakness ist ein Boss-Debuff und gleichzeitig ein Jger-Buff
}



--
local tDebuffInfo;
local function VUHDO_isCustomBuff(aName)
	tDebuffInfo = VUHDO_CUSTOM_DEBUFF_LIST[aName];
	if (tDebuffInfo ~= nil and VUHDO_CUSTOM_BUFF_BLACKLIST[aName] == nil) then
		return tDebuffInfo[1], tDebuffInfo[2];
	else
		return false, false;
	end
end






--
local tSetColor, tSetIcon;
local tIconsSet = { };
local tExpiry, tStacks;
local tDebuffInfo;
local tHasPlayed;
local tInfo;
local tDebuffName, tSoundDebuff;
local tSound;
function VUHDO_determineDebuff(aUnit, aClassName)
	if (not VUHDO_CONFIG["DETECT_DEBUFFS"] or aClassName == nil) then
		return VUHDO_DEBUFF_TYPE_NONE;
	end

	if (VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit] == nil) then
		VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit] = { };
	end

	tIsRmOnly = VUHDO_CONFIG["DETECT_DEBUFFS_REMOVABLE_ONLY"];

	tInfo = VUHDO_RAID[aUnit];
	if (tInfo == nil) then
		return VUHDO_DEBUFF_TYPE_NONE;
	end

	if (tInfo.missbuff ~= nil
		and (not VUHDO_isInFight() or VUHDO_BUFF_SETTINGS["CONFIG"]["BAR_COLORS_IN_FIGHT"])) then
		tChosen = VUHDO_DEBUFF_TYPE_MISSING_BUFF;
	else
		tChosen = VUHDO_DEBUFF_TYPE_NONE;
	end
	tDebuffName = "";
	tSoundDebuff = nil;
	tCnt = 1;

	table.wipe(tIconsSet);
	while (true) do
		tName, _, tIcon, tStacks, tType, _, tExpiry = UnitDebuff(aUnit, tCnt, false);

		if (tIcon == nil or tName == nil) then
			break;
		end

		tSetColor, tSetIcon = VUHDO_isCustomDebuff(tName);
		if (tSetColor) then
			tChosen = VUHDO_DEBUFF_TYPE_CUSTOM;
			tDebuffName = tName;
			tSoundDebuff = tName;
		end

		if (tStacks == nil) then
			tStacks = 0;
		end

		if (tSetIcon) then
			tIconsSet[tName] = { tIcon, tExpiry, tStacks };
			tSoundDebuff = tName;
		end

		tDebuff = VUHDO_DEBUFF_TYPES[tType];

		if (tChosen ~= VUHDO_DEBUFF_TYPE_CUSTOM and tType ~= nil) then
			tAbility = VUHDO_DEBUFF_ABILITIES[VUHDO_PLAYER_CLASS][tDebuff];
			if (not tIsRmOnly or tAbility ~= nil) then
				if (VUHDO_isDebuffRelevant(tName, aClassName)) then

					if (tAbility ~= nil or tChosen == VUHDO_DEBUFF_TYPE_NONE
						or (tChosen == VUHDO_DEBUFF_TYPE_DISEASE and tDebuff == VUHDO_DEBUFF_TYPE_MAGIC)) then
						tChosen = tDebuff;
						if (VUHDO_PANEL_SETUP["BAR_COLORS"].useDebuffIcon) then
							tIconsSet[tName] = { tIcon, tExpiry, tStacks };
						end
					end
				end
			end
		end

  	tCnt = tCnt + 1;
	end

	tCnt = 1;
	while (true) do
		tName, _, tIcon, tStacks, _, _, tExpiry = UnitBuff(aUnit, tCnt, false);

		if (tIcon == nil) then
			break;
		end

		tSetColor, tSetIcon = VUHDO_isCustomBuff(tName);
		if (tSetColor) then
			tChosen = VUHDO_DEBUFF_TYPE_CUSTOM;
			tDebuffName = tName;
			tSoundDebuff = tName;
		end

		if (tStacks == nil) then
			tStacks = 0;
		end

		if (tSetIcon) then
			tIconsSet[tName] = { tIcon, tExpiry, tStacks };
			tSoundDebuff = tName;
		end

  	tCnt = tCnt + 1;
	end

	tHasPlayed = false;
	-- Gained new custom debuff?
	for tName, tDebuffInfo in pairs(tIconsSet) do
		if (VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] == nil) then
			VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] = { tDebuffInfo[2], tDebuffInfo[3] };
			VUHDO_addDebuffIcon(aUnit, tDebuffInfo[1], tName, tDebuffInfo[2], tDebuffInfo[3]);
			if (not VUHDO_IS_CONFIG and VUHDO_MAY_DEBUFF_ANIM) then
				if (tSoundDebuff ~= nil and VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tSoundDebuff] ~= nil) then
					tSound = VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tSoundDebuff].SOUND;
					if (tSound ~= nil
					  and strlen(tSound) > 0
					  and tSound ~= "Interface\\Quiet.mp3"
					  and GetTime() > VUHDO_NEXT_SOUND_TIME) then

						PlaySoundFile(tSound);
						VUHDO_NEXT_SOUND_TIME = GetTime() + 2;
					end
				elseif (VUHDO_CONFIG["CUSTOM_DEBUFF"].SOUND ~= nil
				  and tSound ~= "Interface\\Quiet.mp3"
				  and GetTime() > VUHDO_NEXT_SOUND_TIME) then

					PlaySoundFile(VUHDO_CONFIG["CUSTOM_DEBUFF"].SOUND);
					VUHDO_NEXT_SOUND_TIME = GetTime() + 2;
				end

				tHasPlayed = true;
			end
		-- update number of stacks?
		elseif(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName][1] ~= tDebuffInfo[2]
			or VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName][2] ~= tDebuffInfo[3]) then
  		table.wipe(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName]);
			VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] = { tDebuffInfo[2], tDebuffInfo[3] };
			VUHDO_updateDebuffIcon(aUnit, tDebuffInfo[1], tName, tDebuffInfo[2], tDebuffInfo[3]);
		end
	end

  -- Lost old custom debuff?
  for tName, _ in pairs(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit]) do
  	if (tIconsSet[tName] == nil) then
  		table.wipe(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName]);
  		VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] = nil;
  		VUHDO_removeDebuffIcon(aUnit, tName);
  	end
	end

	-- Play Sound?
	if (VUHDO_CONFIG["SOUND_DEBUFF"] ~= nil
		and tChosen ~= VUHDO_DEBUFF_TYPE_NONE
		and tChosen ~= VUHDO_DEBUFF_TYPE_MISSING_BUFF
		and tChosen ~= VUHDO_DEBUFF_TYPE_CUSTOM
		and not tHasPlayed) then
		if (VUHDO_LAST_UNIT_DEBUFFS[aUnit] ~= tChosen
			and tInfo.range
			and VUHDO_CONFIG["SOUND_DEBUFF"] ~= nil
			and VUHDO_CONFIG["SOUND_DEBUFF"] ~= "Interface\\Quiet.mp3"
			and GetTime() > VUHDO_NEXT_SOUND_TIME) then

			PlaySoundFile(VUHDO_CONFIG["SOUND_DEBUFF"]);
			VUHDO_NEXT_SOUND_TIME = GetTime() + 2;
		end
	end
	if (tInfo.range) then
		VUHDO_LAST_UNIT_DEBUFFS[aUnit] = tChosen;
	end

	return tChosen, tDebuffName;
end



-- Remove debuffing abilities individually not known to the player
local tDebuffName;
local tClass;
function VUHDO_initDebuffs()
	table.wipe(VUHDO_DEBUFF_ABILITIES);
	VUHDO_DEBUFF_ABILITIES = VUHDO_deepCopyTable(VUHDO_INIT_DEBUFF_ABILITIES);
	_, tClass = UnitClass("player");

	for tDebuffType, tAbility in pairs(VUHDO_DEBUFF_ABILITIES[tClass] or { }) do
		if (not VUHDO_isSpellKnown(tAbility)) then
			VUHDO_DEBUFF_ABILITIES[VUHDO_PLAYER_CLASS][tDebuffType] = nil;
		end
	end

	table.wipe(VUHDO_CUSTOM_DEBUFF_LIST);

	for _, tDebuffName in pairs(VUHDO_GLOBAL["VUHDO_CONFIG"]["CUSTOM_DEBUFF"]["STORED"]) do
		VUHDO_CUSTOM_DEBUFF_LIST[tDebuffName] = {
			VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tDebuffName].isColor,
			VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tDebuffName].isIcon
		};
	end
end
