local VUHDO_IS_ON_READY_CHECK = false;



--
local function VUHDO_placeReadyIcon(aButton)
	local tUnit = VUHDO_resolveButtonUnit(aButton);
	local tInfo = VUHDO_RAID[tUnit];

	local tIcon = VUHDO_getBarRoleIcon(aButton, 20);
	if (tInfo == nil or tInfo.isPet) then
		tIcon:Hide();
	else
		UIFrameFlashRemoveFrame(tIcon);
		tIcon:Hide();
		tIcon:SetTexture("Interface\\AddOns\\VuhDo\\Images\\icon_info");
		tIcon:ClearAllPoints();
		tIcon:SetPoint("LEFT", aButton:GetName(), "LEFT", -5, 0);
		tIcon:SetWidth(16);
		tIcon:SetHeight(16);
		tIcon:Show();
	end
end



--
local function VUHDO_placeAllReadyIcons()
	local tPanelNum;
	local tAllButtons;
	local tPanel;
	local tButton;
	for tPanelNum = 1, VUHDO_MAX_PANELS do
		tPanel = VUHDO_getActionPanel(tPanelNum);
		if (tPanel ~= nil) then
			local tAllButtons = { tPanel:GetChildren() };
	
			for _, tButton in pairs(tAllButtons) do
				if (strfind(tButton:GetName(), "HlU", 1, true) and tButton:IsShown()) then
					VUHDO_placeReadyIcon(tButton);
				end
			end
		end
	end
end



--
local function VUHDO_hideAllReadyIcons()
	local tPanelNum;
	local tAllButtons;
	local tPanel;
	local tButton;
	for tPanelNum = 1, VUHDO_MAX_PANELS do
		tPanel = VUHDO_getActionPanel(tPanelNum);
		if (tPanel ~= nil) then
			local tAllButtons = { tPanel:GetChildren() };
	
			for _, tButton in pairs(tAllButtons) do
				if (strfind(tButton:GetName(), "HlU", 1, true) and tButton:IsShown()) then
					UIFrameFlash(VUHDO_getBarRoleIcon(tButton, 20), 0, 2, 10, false, 0, 8);
				end
			end
		end
	end
end



--
function VUHDO_readyCheckStarted()
	VUHDO_IS_ON_READY_CHECK = true;
	VUHDO_hideAllPlayerIcons();
	VUHDO_placeAllReadyIcons();
end



--
local function VUHDO_updateReadyIcon(aUnit, aStatus)
	local tAllButtons = VUHDO_getUnitButtons(aUnit);

	if (tAllButtons == nil) then
		return;
	end

	local tButton;
	local tTexture;

	if (aStatus) then
		tTexture = "Interface\\AddOns\\VuhDo\\Images\\icon_check_2";
	else
		tTexture = "Interface\\AddOns\\VuhDo\\Images\\icon_cancel_1";
	end

	for _, tButton in pairs(tAllButtons) do
		VUHDO_getBarRoleIcon(tButton, 20):SetTexture(tTexture);
	end
end



-- Status 1 = ready, 0 = not ready
function VUHDO_readyCheckConfirm(aUnit, aStatus)
	local tUnit = aUnit;
	if (VUHDO_RAID[tUnit] == nil) then
		return;
	end

	if (not VUHDO_IS_ON_READY_CHECK) then
		VUHDO_readyCheckStarted(aName, aDuration);
	end

	VUHDO_updateReadyIcon(tUnit, aStatus);
end



--
function VUHDO_readyStartCheck(aName, aDuration)
	if (VUHDO_RAID_NAMES[aName] ~= nil) then
		VUHDO_readyCheckConfirm(VUHDO_RAID_NAMES[aName], 1);
	end
end





--
function VUHDO_readyCheckEnds()
	if (not VUHDO_IS_ON_READY_CHECK) then
		return;
	end

	VUHDO_hideAllReadyIcons();
	VUHDO_IS_ON_READY_CHECK = false;
end
