local VUHDO_COLOR_SWATCH;
local VUHDO_COLOR;
local VUHDO_PROHIBIT;
local VUHDO_isTextEdit;
local VUHDO_origColor;


--
local function VUHDO_mayEditText()
	return VUHDO_COLOR.TR ~= nil and not strfind(VUHDO_PROHIBIT, "T", 1, true);
end



--
local function VUHDO_mayEditBackground()
	return VUHDO_COLOR.R ~= nil and not strfind(VUHDO_PROHIBIT, "B", 1, true);
end



--
function VUHDO_setPickerColor(aPanel)
	if (VUHDO_isTextEdit) then
		aPanel:SetColorRGB(VUHDO_COLOR.TR, VUHDO_COLOR.TG, VUHDO_COLOR.TB);
		VuhDoColorPickerColorSwatchOld:SetTexture(VUHDO_COLOR.TR, VUHDO_COLOR.TG, VUHDO_COLOR.TB);

		if (VUHDO_COLOR.TO ~= nil and not strfind(VUHDO_PROHIBIT, "O")) then
			VUHDO_GLOBAL[aPanel:GetName() .. "OpacitySliderFrame"]:Show();
		else
			VUHDO_GLOBAL[aPanel:GetName() .. "OpacitySliderFrame"]:Hide();
		end

	else
		aPanel:SetColorRGB(VUHDO_COLOR.R, VUHDO_COLOR.G, VUHDO_COLOR.B);
		VuhDoColorPickerColorSwatchOld:SetTexture(VUHDO_COLOR.R, VUHDO_COLOR.G, VUHDO_COLOR.B);

		if (VUHDO_COLOR.O ~= nil and not strfind(VUHDO_PROHIBIT, "O")) then
			VUHDO_GLOBAL[aPanel:GetName() .. "OpacitySliderFrame"]:Show();
		else
			VUHDO_GLOBAL[aPanel:GetName() .. "OpacitySliderFrame"]:Hide();
		end
	end

	if (VUHDO_isTextEdit) then
		VUHDO_GLOBAL[aPanel:GetName() .. "OpacitySliderFrameSlider"]:SetValue(floor(VUHDO_COLOR.TO * 100));
	else
		VUHDO_GLOBAL[aPanel:GetName() .. "OpacitySliderFrameSlider"]:SetValue(floor(VUHDO_COLOR.O * 100));
	end
end



--
local tDescription;
function VUHDO_newColorPickerOnShow(aPanel)
	VUHDO_COLOR_SWATCH = aPanel:GetAttribute("swatch");
	VUHDO_COLOR = VUHDO_lnfGetValueFromModel(VUHDO_COLOR_SWATCH);
	
	if (VUHDO_COLOR == nil) then
		VUHDO_Msg("Please save settings first!");
		VuhDoNewColorPicker:Hide();
		return;
	end
	
	VUHDO_origColor = VUHDO_deepCopyTable(VUHDO_COLOR);

	tDescription = VUHDO_COLOR_SWATCH:GetAttribute("description");
	VUHDO_PROHIBIT = VUHDO_COLOR_SWATCH:GetAttribute("prohibit");

	if (VUHDO_PROHIBIT == nil) then
		VUHDO_PROHIBIT = "";
	end

	if (tDescription ~= nil) then
		VUHDO_GLOBAL[aPanel:GetName() .. "TitleLabelLabel"]:SetText("Select " .. tDescription .. " [Drag here]");
	else
		VUHDO_GLOBAL[aPanel:GetName() .. "TitleLabelLabel"]:SetText("Color Select [Drag here]");
	end

	if (VUHDO_mayEditBackground() and VUHDO_mayEditText()) then
		VUHDO_GLOBAL[aPanel:GetName() .. "BackgroundRadioButton"]:SetChecked(true);
		VUHDO_lnfRadioButtonClicked(VUHDO_GLOBAL[aPanel:GetName() .. "BackgroundRadioButton"]);
		VUHDO_GLOBAL[aPanel:GetName() .. "TextRadioButton"]:Show();
		VUHDO_GLOBAL[aPanel:GetName() .. "BackgroundRadioButton"]:Show();
		VUHDO_isTextEdit=false;
	else
		VUHDO_GLOBAL[aPanel:GetName() .. "TextRadioButton"]:Hide();
		VUHDO_GLOBAL[aPanel:GetName() .. "BackgroundRadioButton"]:Hide();
		VUHDO_isTextEdit=VUHDO_mayEditText();
	end

	VUHDO_setPickerColor(aPanel);
end



--
function VUHDO_colorPickerOnColorSelect(anR, anG, anB)
	if (VUHDO_isTextEdit) then
		VUHDO_COLOR.TR = anR;
		VUHDO_COLOR.TG = anG;
		VUHDO_COLOR.TB = anB;
	else
		VUHDO_COLOR.R = anR;
		VUHDO_COLOR.G = anG;
		VUHDO_COLOR.B = anB;
	end
	VUHDO_lnfColorSwatchInitFromModel(VUHDO_COLOR_SWATCH);
	VUHDO_lnfUpdateVarFromModel(VUHDO_COLOR_SWATCH, VUHDO_COLOR);
end



--
function VUHDO_colorPickerOkay()
	VUHDO_lnfUpdateVarFromModel(VUHDO_COLOR_SWATCH, VUHDO_COLOR);
end



--
function VUHDO_colorPickerCancel()
	VUHDO_COLOR = VUHDO_origColor;
	VUHDO_lnfUpdateVarFromModel(VUHDO_COLOR_SWATCH, VUHDO_COLOR);
	VUHDO_lnfColorSwatchInitFromModel(VUHDO_COLOR_SWATCH);
end



--
function VUHDO_colorPickerBackgroundClicked(aPanel)
	VUHDO_isTextEdit = false;
	VUHDO_setPickerColor(aPanel);
end



--
function VUHDO_colorPickerTextClicked(aPanel)
	VUHDO_isTextEdit = true;
	VUHDO_setPickerColor(aPanel);
end



--
local tValue;
function VUHDO_colorPickerOpacityValueChanged(aSlider)
	if (VUHDO_COLOR ~= nil) then
		tValue = VUHDO_GLOBAL[aSlider:GetName() .. "Slider"]:GetValue() / 100;
		if (VUHDO_isTextEdit) then
			VUHDO_COLOR.TO = tValue;
		else
			VUHDO_COLOR.O = tValue;
		end
		VUHDO_lnfColorSwatchInitFromModel(VUHDO_COLOR_SWATCH);
		VUHDO_lnfUpdateVarFromModel(VUHDO_COLOR_SWATCH, VUHDO_COLOR);
	end
end



